package com.connor.cust.box;

import javax.swing.JOptionPane;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.teamcenter.rac.aif.AIFDesktop;
import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
/**
 * : װ䵥
 * :2024-01-05
 * @author  
 * 
 * ޸      ޸    ޸ 
 * 2019-01-24  XXXX   
 */
public class BoxReportHandler extends AbstractHandler{
    
    @Override
    public Object execute(ExecutionEvent arg0) throws ExecutionException {
        System.out.println("BoxReportHandler");
        AIFDesktop desktop = AIFUtility.getActiveDesktop();
        try {
            AbstractAIFUIApplication app = AIFUtility.getCurrentApplication();
            TCSession session = (TCSession) app.getSession();
            InterfaceAIFComponent target = app.getTargetComponent();
            if(target == null || !(target instanceof TCComponentBOMLine)) {
                MessageBox.post(desktop, PlmLocale.getString("nottop"), "ERROR", MessageBox.ERROR);//ѡжBOM㣬ѡ
                return null;
            }
            TCComponentBOMLine bom = (TCComponentBOMLine) target;
            if(bom.parent() != null) {
                MessageBox.post(desktop, PlmLocale.getString("nottop"), "ERROR", MessageBox.ERROR);//ѡжBOM㣬ѡ
                return null;
            }
            String[] options = session.getPreferenceService().getStringValues("KWC_ReportTemplate_XYBOX");
			if(options == null || options.length < 2) {
				MessageBox.post(desktop, "KWC_ReportTemplate_XYBOX" + PlmLocale.getString("preferr"), "ERROR", MessageBox.ERROR);
				return null;
			}
			new Thread() {
				public void run() {
					try {
						int choose = JOptionPane.showOptionDialog(desktop, PlmLocale.getString("choose"), "INFO", 
								JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE, null, 
								new String[] { PlmLocale.getString("multiple"), PlmLocale.getString("single") }, "End");
						if(choose < 0)
							return;
						new BoxReportOperation(session, bom, options, choose == 1).executeOperation();
					}catch(Exception e) {
						e.printStackTrace();
					}
				}
			}.start();
        } catch(Exception e) {
            e.printStackTrace();
            MessageBox.post(desktop, PlmLocale.getString("err") + e.getMessage(), "ERROR", MessageBox.ERROR);
        }
        return null;
    }
}
