package com.connor.cust.box;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedList;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFPrintSetup;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import com.connor.cust.util.POIUtil;
import com.connor.cust.util.ProgressReporterDialog;
import com.connor.cust.util.TCUtil;
import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
/**
 * : װ䵥
 * :2024-01-05
 * @author  
 * 
 * ޸      ޸    ޸ 
 * 2019-01-24  XXXX   
 */
public class BoxReportOperation extends AbstractAIFOperation {
    
    private TCSession session;
    private boolean single;
    private TCComponentBOMLine target;
    private String[] options;
	private LinkedList<String[]> datas;
	private HashMap<String, Integer> boxMap;
	
	private final int PAGE_CNT = 23;//ÿҳ
	private final int TITLE_CNT = 4;//ÿҳͷ
	private final int PAGE = PAGE_CNT + TITLE_CNT;//ÿҳ
	private final int COL_CNT = 9;//ÿҳк
	/**
	 * װ䵥
	 * @param session TCSession
	 * @param target ѡBOM
	 * @param options Excelģѡֵ
	 * @param single Ƿҳ
	 */
    public BoxReportOperation(TCSession session, TCComponentBOMLine target, String[] options, boolean single) {
        this.session = session;
        this.target = target;
        this.options = options;
        this.single = single;
    }
    
    @Override
    public void executeOperation() throws Exception {
		TCComponent model = session.stringToComponent(options[single ? 0 : 1]);
		if(model==null || !model.getType().equals("MSExcelX")) {
			MessageBox.post(AIFUtility.getActiveDesktop(), "KWC_ReportTemplate_XYBOX" + PlmLocale.getString("preferr"), "ERROR", MessageBox.ERROR);
			return;
		}
		File directory = TCUtil.saveExcelChooser();
		if(directory == null)
			return;
		final ProgressReporterDialog reporter = new ProgressReporterDialog("INFO");
		reporter.reportProgressMessage(PlmLocale.getString("importing"));
		new Thread(reporter).start();
		new Thread() {
			public void run(){
				FileInputStream input = null;
				FileOutputStream output = null;
				XSSFWorkbook workbook = null;
		        try {
					datas = new LinkedList<>();
					boxMap = new HashMap<>();
					String topid = target.getProperty("bl_item_item_id");
					recycleBom(target.getChildren(), topid);
					if(datas.size() == 0) {
			            MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("sheetname") + PlmLocale.getString("sheeterr"), "ERROR", MessageBox.ERROR);
			            return;
					}
					//XYBOX
					Collections.sort(datas, new Comparator<String[]>() {
			            public int compare(String[] data1, String[] data2) {
			                return Integer.parseInt(data1[COL_CNT]) - Integer.parseInt(data2[COL_CNT]);
			            }
			        });
					
					File file = ((TCComponentDataset)model).getTcFiles()[0].getFile(System.getProperty("java.io.tmpdir"));
					input = new FileInputStream(file);
					workbook = new XSSFWorkbook(input);
					XSSFSheet sheet = workbook.getSheet(PlmLocale.getString("sheetname"));
					if(sheet == null) {
			            MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("sheetname") + PlmLocale.getString("sheeterr"), "ERROR", MessageBox.ERROR);
			            return;
					}
					int sheet0 = workbook.getSheetIndex(sheet);
					if(single) {
						//ҳ
						XSSFRow xssfrow = TCUtil.getRow(sheet, 0);
						XSSFCell cell = TCUtil.getCell(xssfrow, 9);
						cell.setCellValue(topid);
						int pageCnt = 0;
						for(int b : boxMap.values()) {
							pageCnt += b/PAGE_CNT;
							if(b % PAGE_CNT > 0)
								pageCnt ++;
						}
//						for(int i=1; i<=pageCnt; i++) {
////							sheet.copyRows(0, PAGE, i*PAGE, null);
//							POIUtil.copyRows(workbook, sheet, 0, PAGE-1, i*PAGE, COL_CNT, 1);
//						}
						POIUtil.copyRows(workbook, sheet, 0, PAGE-1, PAGE, COL_CNT, pageCnt - 1);
						int row = 0, rbox = 0, pbox = 0;
						for(String[] data : datas) {
							int box = Integer.parseInt(data[COL_CNT]);
							if(box != pbox) {
								//
								row --;
								int page = row / PAGE;
								if(row % PAGE > 0)
									page ++;
								row = page * PAGE + TITLE_CNT;
								rbox = 1;
								pbox = box;

								xssfrow = TCUtil.getRow(sheet, page * PAGE);
								cell = TCUtil.getCell(xssfrow, 5);
								String[] boxno = PlmLocale.getString("boxno").split(";");
								cell.setCellValue(boxno[0] + getNumStr(box) + boxno[1]);
							}else if(row % PAGE == 1) {
								//ҳ
								xssfrow = TCUtil.getRow(sheet, row);
								cell = TCUtil.getCell(xssfrow, 5);
								String[] boxno = PlmLocale.getString("boxno").split(";");
								cell.setCellValue(boxno[0] + getNumStr(box) + boxno[1]);
								
								int page = row / PAGE + 1;
								row = page * PAGE + TITLE_CNT;
							}
							xssfrow = TCUtil.getRow(sheet, row);
							cell = TCUtil.getCell(xssfrow, 0);
							cell.setCellValue(rbox);
							for(int i=1; i<COL_CNT; i++) {
								if(i == 2)
									continue;
								cell = TCUtil.getCell(xssfrow, i);
								cell.setCellValue(data[i]);
							}
							row ++;
							rbox ++;
						}
					}else {
						//ҳ
						XSSFRow xssfrow = TCUtil.getRow(sheet, 0);
						XSSFCell cell = TCUtil.getCell(xssfrow, 9);
						cell.setCellValue(topid);
						XSSFPrintSetup ps = sheet.getPrintSetup();
						for(int i=0; i<boxMap.size(); i++) {
							XSSFSheet sheet2 = workbook.cloneSheet(sheet0);
							workbook.setSheetOrder(sheet2.getSheetName(), sheet0+i+1);
							XSSFPrintSetup ps2 = sheet2.getPrintSetup();
							ps2.setLandscape(ps.getLandscape());
							ps2.setPaperSize(ps.getPaperSizeEnum());
						}
						int row = 0, rbox = 0, pbox = 0;
						for(String[] data : datas) {
							int box = Integer.parseInt(data[COL_CNT]);
							if(box != pbox) {
								//
								sheet = workbook.getSheetAt(sheet0 + box - 1);
								row = TITLE_CNT;
								rbox = 1;
								pbox = box;

								xssfrow = TCUtil.getRow(sheet, 0);
								cell = TCUtil.getCell(xssfrow, 5);
								String[] boxno = PlmLocale.getString("boxno").split(";");
								cell.setCellValue(boxno[0] + getNumStr(box) + boxno[1]);
							}
							xssfrow = TCUtil.getRow(sheet, row);
							cell = TCUtil.getCell(xssfrow, 0);
							cell.setCellValue(rbox);
							for(int i=1; i<COL_CNT; i++) {
								if(i == 2)
									continue;
								cell = TCUtil.getCell(xssfrow, i);
								cell.setCellValue(data[i]);
							}
							row ++;
							rbox ++;
						}
					}
					
					output = new FileOutputStream(file.getPath());
					workbook.write(output);
					workbook.close();
					output.close();
					input.close();
					if(directory.exists())
						directory.delete();
					file.renameTo(directory);
					
					reporter.requestCanceling();
					MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("exportsuccess"), "INFO", MessageBox.INFORMATION);
		        } catch (Exception e1) {
		            e1.printStackTrace();
					reporter.requestCanceling();
		            MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("err") + e1.getMessage(), "ERROR", MessageBox.ERROR);
		        }finally {
		        	try {
						if(workbook != null)
							workbook.close();
						if(output != null)
							output.close();
						if(input != null)
							input.close();
		        	} catch (Exception e1) {
			            e1.printStackTrace();
			        }
				}
			}
		}.start();
    }
    /**
	 * BOMȡ
	 * @param contexts BOM.getChildren()
	 * @param pid item_id
	 */
	private void recycleBom(AIFComponentContext[] contexts, String pid) throws Exception {
		for(AIFComponentContext c : contexts) {
			TCComponentBOMLine bom = (TCComponentBOMLine) c.getComponent();
			String id = bom.getProperty("bl_item_item_id");
			String box = bom.getProperty("XYBOX");
			if(!box.isEmpty()) {
				TCComponentItemRevision rev = bom.getItemRevision();
				String[] data = new String[COL_CNT + 1];
				data[0] = "";
				data[1] = id;
				data[2] = "";
				data[3] = rev.getProperty("object_name");
				data[4] = TCUtil.getItemRevisionMasterForm(rev).getProperty("item_id");
				data[5] = pid;
				data[6] = bom.getProperty("Detail_ID");
				data[7] = bom.getProperty("bl_quantity");
				data[8] = "";
				data[9] = box;
				
				if(boxMap.containsKey(box))
					boxMap.put(box, boxMap.get(box) + 1);
				else
					boxMap.put(box, 1);
				datas.add(data);
			}
			recycleBom(bom.getChildren(), id);
		}
	}
    /**
	 * תΪʽ
	 * @param num ת
	 */
	private String getNumStr(int num) throws Exception {
		String[] nums = PlmLocale.getString("numstr").split(";");
		StringBuilder numstr = new StringBuilder("");
		if(num < 11) {
			numstr.append(nums[num]);
		}else if(num < 20) {
			numstr.append(nums[10]).append(nums[num%10]);
		}else if(num%10 == 0) {
			numstr.append(nums[num/10]).append(nums[10]);
		}else {
			numstr.append(nums[num/10]).append(nums[10]).append(nums[num%10]);
		}
		
		return numstr.toString();
	}
    
}