package com.connor.cust.box;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;

import com.connor.cust.util.TCUtil;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentListOfValues;
import com.teamcenter.rac.kernel.TCComponentListOfValuesType;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
/**
 * : BOMװ䵥д
 * :2024-01-04
 * @author  
 * 
 * ޸      ޸    ޸ 
 * 2019-01-24  XXXX   
 */
public class XYBOMDialog extends AbstractAIFDialog {
    private static final long serialVersionUID = 1L;
//    private TCSession session;
    private JButton cancelBtn;
    private JButton okBtn;
    private JComboBox<String> box;
    
    public XYBOMDialog(TCSession session, InterfaceAIFComponent[] targets) throws Exception {
        super(AIFUtility.getActiveDesktop());
//        this.session = session;
        setTitle(PlmLocale.getString("setbox"));
        
//        JLabel label1 = new JLabel("Դ");
//        add(label1);
//        label1.setBounds(20, 20, 90, 23);
        box = new JComboBox<>();
        box.setEditable(true);
        box.addItem("");
        TCComponentListOfValuesType lovType = (TCComponentListOfValuesType)session.getTypeComponent("ListOfValues");
        TCComponentListOfValues[] lovs = lovType.find("KWC6_DTLOV_ZXBOX");
        if(lovs.length > 0) {
            for(String s : TCUtil.getDynamicLOV(session, lovs[0])) {
                box.addItem(s);
            }
        }
        add(box);
        box.setBounds(30, 20, 200, 23);
        
        okBtn = new JButton(PlmLocale.getString("ok"));
        add(okBtn);
        okBtn.setBounds(30, 100, 80, 23);
        cancelBtn = new JButton(PlmLocale.getString("cel"));
        add(cancelBtn);
        cancelBtn.setBounds(150, 100, 80, 23);
        add(new JLabel(""));
        
        addActionListener(session, targets);
        
        pack();
        setSize(new Dimension(350, 200));
        setDefaultLookAndFeelDecorated(true);
        Dimension screen = getToolkit().getScreenSize();
        setLocation((screen.width - getSize().width) / 2, (screen.height - getSize().height) / 2);
//        setAlwaysOnTop(true);
        setVisible(true);
    }

    private void addActionListener(TCSession session, InterfaceAIFComponent[] targets) {
        okBtn.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                try {
                    String value = box.getSelectedItem().toString();
                    TCUtil.setByPass(session, true);
                    for(InterfaceAIFComponent t : targets) {
                        ((TCComponentBOMLine)t).setProperty("XYBOX", value);
                    }
                    MessageBox.post(XYBOMDialog.this, PlmLocale.getString("boxfinish"), "INFO", MessageBox.INFORMATION);//װ䵥ɣ
                } catch (Exception e1) {
                    e1.printStackTrace();
                    MessageBox.post(XYBOMDialog.this, PlmLocale.getString("err") + e1.getMessage(), "ERROR", MessageBox.ERROR);
                }finally {
                    try {
                        TCUtil.setByPass(session, false);
                    } catch (Exception e1) {
                        e1.printStackTrace();
                    }
                }
            }
        });
        cancelBtn.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                dispose();
            }
        });
    }
}