package com.connor.cust.classification;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.ByteArrayInputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.methods.InputStreamRequestEntity;
import org.apache.commons.httpclient.methods.PostMethod;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.connor.cust.box.PlmLocale;
import com.connor.cust.util.TCUtil;

//import org.apache.axiom.om.OMAbstractFactory;
//import org.apache.axiom.om.OMElement;
//import org.apache.axiom.om.OMFactory;
//import org.apache.axiom.om.OMNamespace;
//import org.apache.axis2.AxisFault;
//import org.apache.axis2.addressing.EndpointReference;
//import org.apache.axis2.client.Options;
//import org.apache.axis2.client.ServiceClient;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCClassificationService;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentICO;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.ics.ICSKeyLov;
import com.teamcenter.rac.kernel.ics.ICSProperty;
import com.teamcenter.rac.kernel.ics.ICSPropertyDescription;
import com.teamcenter.rac.util.MessageBox;
//import net.sf.json.JSONArray;

/**
 * ޸ķ
 */
public class EditClassificationDialog extends AbstractAIFDialog {

	private static final long serialVersionUID = 1L;
//	private AbstractAIFApplication app;
	private TCSession session;
	private String address;
//	private TCComponent target;
	private Map<String, JComponent> propMap;
	private TCComponentItem item;
	private int[] ids;
	private String[] values;
	private String[] names;
	private boolean finished;
	private ICSPropertyDescription[] desc;

	public EditClassificationDialog(AbstractAIFApplication app) throws Exception {
//		this.app = app;
		this.session = (TCSession) app.getSession();
//		this.myService = session.getClassificationService();
		InterfaceAIFComponent target = AIFUtility.getCurrentApplication().getTargetComponent();

		if (!(target instanceof TCComponentItem)) {
			MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("chooserev"), "ERROR", MessageBox.ERROR);
			return;
		}
        address = session.getPreferenceService().getStringValue("Autocode_SendClassServer_URL");
		if(address == null || address.isEmpty()) {
			MessageBox.post(AIFUtility.getActiveDesktop(), "Autocode_SendClassServer_URL" + PlmLocale.getString("preferr"), "ERROR", MessageBox.ERROR);
			return;
		}
        String[] options = session.getPreferenceService().getStringValues("KWC_IDAddrule");
		if(options == null || options.length == 0) {
			MessageBox.post(AIFUtility.getActiveDesktop(), "KWC_IDAddrule" + PlmLocale.getString("preferr"), "ERROR", MessageBox.ERROR);
			return;
		}
		item = (TCComponentItem) target;
		if(!TCUtil.contains(options, item.getType())) {
			MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("notinoptions"), "ERROR", MessageBox.ERROR);
			return;
		}
		boolean isAccess = session.getTCAccessControlService().checkPrivilege(item, "WRITE");
		if (!isAccess) {
			MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("noaccess"), "ERROR", MessageBox.ERROR);
			return;
		}
		if(item.getReferenceListProperty("revision_list").length > 1) {
			MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("revcounterr"), "ERROR", MessageBox.ERROR);
			return;
		}
		if(item.getLatestItemRevision().getDateProperty("date_released") != null) {
			MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("statuserr"), "ERROR", MessageBox.ERROR);
			return;
		}
//		System.out.println("deleteClass:" + deleteClass("UID"));
		initUI();
	}
	
	@SuppressWarnings("unchecked")
	private void initUI() throws Exception {
		this.setTitle(PlmLocale.getString("classtitle"));

		JPanel rootPanel = new JPanel();
		rootPanel.setLayout(null);
		rootPanel.setPreferredSize(new Dimension(600, 350));

		Map<ICSProperty, ICSPropertyDescription> displayMap = new LinkedHashMap<ICSProperty, ICSPropertyDescription>();
		propMap = new HashMap<String, JComponent>();

		if (item.getClassificationClass() != null && !"".equals(item.getClassificationClass())) {
			try {
				item.refresh();
				System.out.println("rev.getClassificationClass()=" + item.getClassificationClass());
				TCComponentICO ico = item.getClassificationObjects()[0];
				ICSProperty[] props = ico.getICSProperties(true);
				desc = ico.getICSPropertyDescriptors();
				for (int i = 0; i < props.length; i++) {
//					System.out.println(props[i].getId() + "===>" + props[i].getValue());// 30101===>
					// desc.getName=Type and size series ǷԵ||| desc.getId=30101ǷID
//					System.out.println("desc.getName=" + desc[i].getName() + " desc.getId=" + desc[i].getId());
					displayMap.put(props[i], desc[i]);
				}
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		} else {
			this.disposeDialog();
			MessageBox.post(AIFUtility.getActiveDesktop(), PlmLocale.getString("noclasserr"), "ERROR", MessageBox.ERROR);
			return;
		}

		if (displayMap.size() == 0) {
			return;
		}

		JPanel content = new JPanel();
		content.setLayout(null);
		content.setPreferredSize(new Dimension(600, displayMap.size() * (25 + 10)));

		int num = 0;
		// ͨȡеķԣȻ
		for (Entry<ICSProperty, ICSPropertyDescription> entry : displayMap.entrySet()) {
			JLabel label = new JLabel(entry.getValue().getName() + "");
			label.setBounds(10, num * 35 + 10, 100, 25);

			ICSKeyLov lov = entry.getValue().getFormat().getKeyLov();
//			ArrayList<Object> list = new ArrayList<>();
			if (lov != null) {
				String[] keys = lov.getKeys();
				JAutoCompleteComboBox combo = new JAutoCompleteComboBox();
//				JComboBox<ClassPropBean> combo = new JComboBox<ClassPropBean>();
				combo.addItem(new ClassPropBean("", "", ""));
				for (String key : keys) {
					combo.addItem(new ClassPropBean(key, lov.getValueOfKey(key), ""));
				}

				String v = entry.getKey().getValue();
				for (int i = 0; i < combo.getItemCount(); i++) {
					if (v.equals(((ClassPropBean) combo.getItemAt(i)).getId())) {
						combo.setSelectedIndex(i);
						break;
					}
				}
//				combo.setSelectedItem(v);
//				if (!Arrays.asList(lov.getDisplayValues()).contains(v)) {
//					combo.addItem(v);
//					combo.setSelectedItem(v);
//				}

				combo.setBounds(130, num * 35 + 10, 350, 25);

				propMap.put(entry.getValue().getName(), combo);
				content.add(combo);
			} else {
				JTextField text = new JTextField(entry.getKey().getValue());
				text.setBounds(130, num * 35 + 10, 350, 25);
				propMap.put(entry.getValue().getName(), text);
				content.add(text);
			}

			content.add(label);

			num++;
		}

		JButton okBtn = new JButton(PlmLocale.getString("ok"));
		okBtn.setBounds(40, 310, 100, 25);
		okBtn.setSelected(true);
		okBtn.addActionListener(ok());
		JButton cancelBtn = new JButton(PlmLocale.getString("cel"));
		cancelBtn.setBounds(160, 310, 100, 25);
		cancelBtn.addActionListener(cancel());

		JScrollPane jsp = new JScrollPane(content);
		jsp.getVerticalScrollBar().setUnitIncrement(16);
		jsp.setBounds(0, 0, 600, 300);
		jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		rootPanel.add(jsp);
		rootPanel.add(okBtn);
		rootPanel.add(cancelBtn);
		this.add(rootPanel);
		this.pack();
		this.centerToScreen();
		this.setAutoRequestFocus(true);
//		this.setResizable(false);
		this.setAlwaysOnTop(true);
		this.showDialog();
	}

	private ActionListener ok() {
		return new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					((JButton) e.getSource()).setEnabled(false);
//					TCComponentItemRevision rev = item.getLatestItemRevision();

					new Thread(new Runnable() {
						@Override
						public void run() {
							int i = 1;
							while (!finished) {
								try {
									setTitle("޸ķ " + createPoint(i++ % 3));
									Thread.sleep(200);
								} catch (Exception e) {
									e.printStackTrace();
								}
							}
						}
					}).start();

					setAlwaysOnTop(false);
					if (saveClassification()) {
						MessageBox.post(EditClassificationDialog.this, "޸ķԳɹ", "INFO", MessageBox.INFORMATION);
						disposeDialog();
					} else {
						MessageBox.post(EditClassificationDialog.this, "޸ķʧܣ", "ERROR", MessageBox.ERROR);
					}
				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(EditClassificationDialog.this, PlmLocale.getString("err") + e1.toString(), "ERROR", MessageBox.ERROR);
				}
			}
		};
	}

	private ActionListener cancel() {
		return new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				disposeDialog();
			}
		};
	}

	@SuppressWarnings("unchecked")
	private boolean saveClassification() {
		try {
//			TCComponentForm form = (TCComponentForm) rev.getRelatedComponents("IMAN_master_form_rev")[0];
//			TCComponent[] status = form.getRelatedComponents("release_status_list");
//			for (TCComponent comp : status) {
//				if (comp.getProperty("object_name").contains("ʽ")) {
//					JOptionPane.showMessageDialog(this, "汾ʽ޸ķ", "ʾ", JOptionPane.WARNING_MESSAGE);
//					return false;
//				}
//			}
			TCComponentICO[] icoS = item.getClassificationObjects();
//			System.out.println("======>ȡķ:" + icoS.length);
			if (icoS == null || icoS.length == 0) {
				return false;
			}
			String classID = item.getClassificationClass();
			ArrayList<ClassProperty> propList = new ArrayList<>();
			TCComponentICO ico = icoS[0];
			ICSPropertyDescription[] desc = ico.getICSPropertyDescriptors();
			ICSProperty[] oldICSProps = ico.getICSProperties(true);
			ids = new int[oldICSProps.length];
			values = new String[oldICSProps.length];
			names = new String[oldICSProps.length];
			StringBuilder id = new StringBuilder("");
			StringBuilder json = new StringBuilder("");
			// "[{\"value\":\"1\",\"propertyID\":-500003},{\"value\":\"1\",\"propertyID\":-500011}]"
			for (int j = 0; j < oldICSProps.length; j++) {
				ids[j] = oldICSProps[j].getId();
				if (propMap.get(desc[j].getName()) instanceof JComboBox) {
					ClassPropBean bean = (ClassPropBean) ((JComboBox<ClassPropBean>) propMap.get(desc[j].getName())).getSelectedItem();
					String str = bean.getId();
					values[j] = " ".equals(str) ? "" : str;
				} else {
					values[j] = ((JTextField) propMap.get(desc[j].getName())).getText();
				}
				names[j] = desc[j].getName();
				ClassProperty prop = new ClassProperty(ids[j], values[j]);
				propList.add(prop);
				id.append("/").append(values[j]);
				json.append(",{\"value\":\"").append(values[j]).append("\",\"propertyID\":\"").append(ids[j]).append("\"}");
			}
//			String json = "";//objectToJson(propList);
			System.out.println("classID=" + classID);
//			System.out.println("json=" + json);
//			System.out.println("ɾ...");
			String[] result = deleteClass(getICO(item, classID).getUid()).split("&&");
			if(!result[0].equals("200")) {
				MessageBox.post(EditClassificationDialog.this, 
						String.format("%s%s%s%s%s%s", PlmLocale.getString("delete"), PlmLocale.getString("message1"), PlmLocale.getString("message2"), 
								result[0], PlmLocale.getString("message3"), result[1]), "ERROR", MessageBox.ERROR);
				return false;
			}
			JSONObject resultJson = JSON.parseObject(result[1]);
			Boolean success = resultJson.getBoolean("Status");
			if(!success) {
				MessageBox.post(EditClassificationDialog.this, 
						String.format("%s%s%s%s", PlmLocale.getString("delete"), PlmLocale.getString("message1"), PlmLocale.getString("message3"), 
								result[1]), "ERROR", MessageBox.ERROR);
				return false;
			}
			
//			System.out.println("ͷ...");
			result = sendToClass(item.getUid(), classID, "["+json.substring(1)+"]").split("&&");
			if(!result[0].equals("200")) {
				MessageBox.post(EditClassificationDialog.this, 
						String.format("%s%s%s%s%s%s", PlmLocale.getString("send"), PlmLocale.getString("message1"), PlmLocale.getString("message2"), 
								result[0], PlmLocale.getString("message3"), result[1]), "ERROR", MessageBox.ERROR);
				return false;
			}
			resultJson = JSON.parseObject(result[1]);
			success = resultJson.getBoolean("Status");
			if(!success) {
				MessageBox.post(EditClassificationDialog.this, 
						String.format("%s%s%s%s", PlmLocale.getString("send"), PlmLocale.getString("message1"), PlmLocale.getString("message3"), 
								result[1]), "ERROR", MessageBox.ERROR);
				return false;
			}
			String newid = id.substring(1);
			System.out.println("newid:"+newid);
			/**/
			String oldid = item.getProperty("item_id");
			item.setProperty("item_id", newid);
			TCComponent itemForm = item.getRelatedComponents("IMAN_master_form")[0];
			itemForm.setProperty("object_name", itemForm.getProperty("object_name").replaceAll(oldid, newid));
			TCComponent revForm = item.getLatestItemRevision().getRelatedComponents("IMAN_master_form_rev")[0];
			revForm.setProperty("object_name", revForm.getProperty("object_name").replaceAll(oldid, newid));
		} catch (Exception e1) {
			e1.printStackTrace();
			MessageBox.post(EditClassificationDialog.this, PlmLocale.getString("err") + e1.toString(), "ʾ", MessageBox.ERROR);
			return false;
		}
		return true;
	}

	private TCComponentICO getICO(TCComponent target, String classId) throws Exception {
		if (target == null || classId.equals("")) {
			return null;
		}
		TCComponentICO[] icos = target.getClassificationObjects();
		System.out.println(target + " -> Ѵڷࣺ" + Arrays.toString(icos));
		int len = icos.length;
		if (len == 0) {
			return null;
		}
		TCClassificationService classService = session.getClassificationService();
		for (int i = 0; i < len; i++) {
			TCComponentICO ico = icos[i];
			classService.loadICOs(new String[] { ico.getUid() }, "");
			if (ico.getClassId() == null || ico.getClassId().equals("")) {
				throw new Exception("쳣ϵԱ");
			}
			if (classId.equals(ico.getClassId())) {
				return ico;
			}
		}
		return null;
	}

	/**
	* ȡLOVʾֵ
	* @param icsD
	* @return
	*/
	public static String getClassDisplayableValue(ICSPropertyDescription icsD) {
		String result = "";
		ICSKeyLov lov = icsD.getFormat().getKeyLov();
		if (lov != null) {
			String[] keys = lov.getKeys();
			for (String key : keys) {
				result = lov.getValueOfKey(key);
				return result;
			}
		}
		return result;
	}
	
	private String createPoint(int num) {
		StringBuilder sb = new StringBuilder();
		while (num > 0) {
			sb.append(".");
			num--;
		}
		return sb.toString();
	}
	
	private String deleteClass(String icoPuid) throws Exception {
		String soapRequestData = "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
				+ "<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">"
				+ "<soap:Body><DeleteClass xmlns=\"http://tempuri.org/\"><icoPuid>"
				+ icoPuid 
				+ "</icoPuid></DeleteClass></soap:Body></soap:Envelope>";

		System.out.println("xml:"+soapRequestData);
		System.out.println("address:"+address);
		PostMethod postMethod = new PostMethod(address);
		byte[] b = soapRequestData.getBytes("utf-8");
		ByteArrayInputStream is = new ByteArrayInputStream(b, 0, b.length);
		InputStreamRequestEntity re = new InputStreamRequestEntity(is, b.length, "text/xml; charset=utf-8");
		postMethod.setRequestEntity(re);
		
		HttpClient httpClient = new HttpClient();
		int statusCode = httpClient.executeMethod(postMethod);
		soapRequestData = postMethod.getResponseBodyAsString();
		System.out.println("soapRequestData="+soapRequestData);
		
		//TODO 
		// 200˵
		
		if(soapRequestData.indexOf("<DeleteClassResult>")>0) {
			soapRequestData = soapRequestData.substring(soapRequestData.indexOf("<DeleteClassResult>") + 19, soapRequestData.indexOf("</DeleteClassResult>"));
		}
		return statusCode+"&&"+soapRequestData;
	}
	
	private String sendToClass(String wsoPUID, String classID, String json) throws Exception {
		String soapRequestData = "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
				+ "<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">"
				+ "<soap:Body><SendToClass xmlns=\"http://tempuri.org/\">"
				+ "<wsoPuiid>"+wsoPUID+"</wsoPuiid>"
				+ "<classID>"+classID+"</classID>"
				+ "<JsonContainer>"+json+"</JsonContainer></SendToClass></soap:Body></soap:Envelope>";

		System.out.println("xml:"+soapRequestData);
		System.out.println("address:"+address);
		PostMethod postMethod = new PostMethod(address);
		byte[] b = soapRequestData.getBytes("utf-8");
		ByteArrayInputStream is = new ByteArrayInputStream(b, 0, b.length);
		InputStreamRequestEntity re = new InputStreamRequestEntity(is, b.length, "text/xml; charset=utf-8");
		postMethod.setRequestEntity(re);
		
		HttpClient httpClient = new HttpClient();
		int statusCode = httpClient.executeMethod(postMethod);
		soapRequestData = postMethod.getResponseBodyAsString();
		System.out.println("soapRequestData="+soapRequestData);
		
		//TODO 
		// 200˵

		if(soapRequestData.indexOf("<SendToClassResult>")>0) {
			soapRequestData = soapRequestData.substring(soapRequestData.indexOf("<SendToClassResult>") + 19, soapRequestData.indexOf("</SendToClassResult>"));
		}
		return statusCode+"&&"+soapRequestData;
	}
/*
	public void deleteClass(String icoPuid) {
		try {
			ServiceClient sc = new ServiceClient();
			Options opts = new Options();
			String url = JDMethodUtil.getPrefStr("Autocode_SendClassServer_URL", session);// "http://10.201.5.203:19090/ErpWebService.asmx?WSDL";
			EndpointReference end = new EndpointReference(url);
			opts.setTo(end);
			opts.setAction("DeleteClass");
			sc.setOptions(opts);
			OMFactory fac = OMAbstractFactory.getOMFactory();
			OMNamespace omNs = fac.createOMNamespace("http://tempuri.org/", "");
			OMElement method = fac.createOMElement("DeleteClass", omNs);
			OMElement value = fac.createOMElement("icoPuid", omNs);
			value.setText(icoPuid);

			method.addChild(value);

			OMElement res = sc.sendReceive(method);
			res.getFirstElement().getText();
			System.out.println(res.getFirstElement().getText());
		} catch (AxisFault e) {
			e.printStackTrace();
		}

	}

	public boolean sendToClass(String wsoPUID, String classID, String json) {
		try {
			ServiceClient sc = new ServiceClient();
			Options opts = new Options();
			String url = JDMethodUtil.getPrefStr("Autocode_SendClassServer_URL", session);
			// "http://10.201.5.203:19090/ErpWebService.asmx?WSDL";
			EndpointReference end = new EndpointReference(url);
			opts.setTo(end);
			opts.setAction("SendToClass");
			sc.setOptions(opts);
			OMFactory fac = OMAbstractFactory.getOMFactory();
			OMNamespace omNs = fac.createOMNamespace("http://tempuri.org/", "");
			OMElement method = fac.createOMElement("SendToClass", omNs);
			OMElement value = fac.createOMElement("wsoPuiid", omNs);
			value.setText(wsoPUID);
			OMElement value1 = fac.createOMElement("classID", omNs);
			value1.setText(classID);
			OMElement value2 = fac.createOMElement("JsonContainer", omNs);
			// "[{\"value\":\"1\",\"propertyID\":-500003},{\"value\":\"1\",\"propertyID\":-500011}]"
			value2.setText(json);

			method.addChild(value);
			method.addChild(value1);
			method.addChild(value2);

			OMElement res = sc.sendReceive(method);
			res.getFirstElement().getText();
			System.out.println(res.getFirstElement().getText());
		} catch (AxisFault e) {
//			MessageBox.post("ͷʧܣ", "", MessageBox.ERROR);
			e.printStackTrace();
			return false;
		}
		return true;

	}

	public static String objectToJson(List<ClassProperty> props) {
		String str = null;
		try {
			JSONArray json = JSONArray.fromObject(props);// javaתΪjson
			str = json.toString();// jsonתΪַ
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println("JSON =>" + str);
		return str;
	}*/
}
