package com.connor.cust.util;

import java.awt.Frame;
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Vector;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JTable;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.filechooser.FileSystemView;

import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;

import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.ListOfValuesInfo;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentContextList;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetType;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentListOfValues;
import com.teamcenter.rac.kernel.TCComponentListOfValuesType;
import com.teamcenter.rac.kernel.TCComponentPseudoFolder;
import com.teamcenter.rac.kernel.TCComponentQuery;
import com.teamcenter.rac.kernel.TCComponentQueryType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCQueryClause;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.services.rac.core.LOVService;
import com.teamcenter.services.rac.core._2013_05.LOV.InitialLovData;
import com.teamcenter.services.rac.core._2013_05.LOV.LOVSearchResults;
import com.teamcenter.services.rac.core._2013_05.LOV.LOVValueRow;
import com.teamcenter.services.rac.core._2013_05.LOV.LovFilterData;

public class TCUtil {
	public static final int MINWIDTH = 1280;
	public static final int MINHEIGHT = 768;
	
	public static TCComponentBOMWindow getWindow(TCSession session) throws Exception{
		TCComponentBOMWindow window = null;
		TCComponentBOMWindowType bomWinType = (TCComponentBOMWindowType) session.getTypeComponent("BOMWindow");
		window = bomWinType.create(null);
		return window;
	}

	public static TCComponentBOMLine getBOMLine(TCSession session,TCComponentBOMWindow window, TCComponentItemRevision revision) 
			throws Exception {
		TCComponentBOMLine bomLine = window.setWindowTopLine(null, revision, null, null);
		window.save();
		return bomLine;
	}
	public static TCComponentPseudoFolder getPseudoFolder(TCComponent parent, String relation) throws Exception {
		TCComponentPseudoFolder pseudoFolder = null;
		AIFComponentContext[] comps = parent.getChildren();
		if (comps != null && comps.length > 0 && comps[0] != null) {
			for (int i = 0; i < comps.length; i++) {
				TCComponent comp = (TCComponent) comps[i].getComponent();
				if (comp instanceof TCComponentPseudoFolder) {
					if (comp.isTypeOf("PseudoFolder")) {
//						System.out.println("PseudoFolder type:" + comp.getDefaultPasteRelation());
						if (comp.getDefaultPasteRelation().equalsIgnoreCase(relation)) {
							pseudoFolder = (TCComponentPseudoFolder) comp;
							break;
						}
					}
				}
			}
		}
		return pseudoFolder;
	}
	public static TCComponentForm getItemRevisionMasterForm(TCComponentItemRevision revision) throws Exception {
		if (revision != null) {
			AIFComponentContext[] contexts = revision.getChildren("IMAN_master_form_rev");
			if (contexts != null && contexts.length > 0) {
				InterfaceAIFComponent component = contexts[0].getComponent();
				if (component instanceof TCComponentForm) {
					return (TCComponentForm) component;
				}
			}
		}
		return null;
	}

	public static LinkedHashMap<String, String> getlovValues(TCSession session, String lovName) throws TCException {
		LinkedHashMap<String, String> lovVal = new LinkedHashMap<String, String>();
		TCComponentListOfValuesType lovType = (TCComponentListOfValuesType) session.getTypeComponent("ListOfValues");
		TCComponentListOfValues[] lovs = lovType.find(lovName);
		if (lovs != null && lovs.length > 0) {
			TCComponentListOfValues lov = lovs[0];
			ListOfValuesInfo lovInfo = lov.getListOfValues();
			String[] code = lovInfo.getStringListOfValues();
			String[] name = lovInfo.getLOVDisplayValues();
			if (code != null && name != null) {
				for (int i = 0; i < code.length; i++) {
					// System.out.printf("code[%d]=%s name[%d]=%s \n", i, code[i], i, name[i]);
					lovVal.put(code[i], name[i]);
				}
			}
			return lovVal;
		}
		return null;
	}

	public static String getTableValue(JTable table, int row, int col){
		Object val = table.getValueAt(row, col);
		if(val==null)
			return "";
		else
			return val.toString();
	}
	/**
	 * ѯѯ
	 * @param session TCSession
	 * @param queryName ѯ
	 * @param aKey ѯĿ
	 * @param aVal ѯֵ
	 * @return ѯ
	 */
	public static TCComponent[] query(TCSession session, String queryName, String[] aKey, String[] aVal) throws Exception {
		TCComponentQueryType imanQueryType = (TCComponentQueryType) session.getTypeComponent("ImanQuery");
		TCComponentQuery imancomponentquery = (TCComponentQuery) imanQueryType.find(queryName);
		if (imancomponentquery == null) {
			throw new Exception("δҵѯ " + queryName + "!");
		}
		aKey = session.getTextService().getTextValues(aKey);
//		for (int i = 0; i < aKey.length; i++) {
//			System.out.println(aKey[i] + "===============" + aVal[i]);
//		}
		TCComponentContextList componentContextList = imancomponentquery.getExecuteResultsList(aKey, aVal);
		return componentContextList.toTCComponentArray();
	}
	/**
	 * ѯѯֲ֧ѯĬ
	 * @param session TCSession
	 * @param queryName ѯ
	 * @param Keys ѯĿ
	 * @param Vals ѯֵ
	 * @return ѯ
	 */
	public static TCComponent[] query(TCSession session, String queryName, Vector<String> Keys, Vector<String> Vals) throws Exception {
		TCComponentQueryType imanQueryType = (TCComponentQueryType) session.getTypeComponent("ImanQuery");
		TCComponentQuery imancomponentquery = (TCComponentQuery) imanQueryType.find(queryName);
		if (imancomponentquery == null) {
			System.out.println("δҵѯ" + queryName);
			throw new Exception("Query:"+queryName+" cannot find");
		}
		TCQueryClause[] qc = imancomponentquery.describe();
//		Map<String, String> clauseMap = new HashMap<>();
		for(TCQueryClause c : qc) {
			String key = c.getUserEntryNameDisplay();
			String value = c.getDefaultValue();
//			System.out.println(key + "==>" + c.getAttributeName());
			if(!value.trim().isEmpty() && !Keys.contains(key)) {
				if(key.isEmpty())
					Keys.add(c.getAttributeName());
				else
					Keys.add(key);
				Vals.add(value);
			}
		}
		int size = Keys.size();
		String[] keyA = new String[size];
		String[] valueA = new String[size];
		for(int i=0; i<size; i++) {
			keyA[i] = Keys.get(i);
			valueA[i] = Vals.get(i);
			System.out.println(keyA[i] + ":" + valueA[i]);
		}
		TCComponentContextList componentContextList = imancomponentquery.getExecuteResultsList(keyA, valueA);
		return componentContextList.toTCComponentArray();
	}
	public static String getSerialNo(TCSession session, String itemId, String objectType) throws Exception {
		TCComponent[] comps = null;
		if (objectType.equals("")) {
			comps = query(session, " ID", new String[] { "ItemID" }, new String[] { itemId + "*" });
		} else {
			comps = query(session, "...", new String[] { "ItemID", "Type" }, new String[] { itemId + "*", objectType });
		}
//		System.out.println("getSerialNo comps.len:" + (comps == null ? 0 : comps.length));
		if (comps.length > 0) {
			Integer maxId = 0;
			for (TCComponent comp : comps) {
				String pid = comp.getProperty("item_id");
				System.out.println("pid:" + pid);
				String pidSuffix = pid.substring(pid.length() - 3);
				if (Integer.parseInt(pidSuffix) > maxId) {
					maxId = Integer.parseInt(pidSuffix);
				}
			}
			return String.format("%03d", maxId + 1);
		}
		return "001";
	}

	/**
	 * Excel·ѡ
	 * @return ѡExcel·ļ
	 */
	public static File saveExcelChooser() {
		File dir = null;
		JFileChooser chooser = new JFileChooser();
		chooser.setAcceptAllFileFilterUsed(false);
//		File currentDir = FileSystemView.getFileSystemView().getDefaultDirectory();
		File desktopDir = FileSystemView.getFileSystemView().getHomeDirectory();
		chooser.setCurrentDirectory(desktopDir);
		String saveType[] = { "xlsx" };
		chooser.setFileFilter(new FileNameExtensionFilter("Excel", saveType));
		Frame frame = new Frame();
		int returnVal = chooser.showSaveDialog(frame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			dir = chooser.getSelectedFile();
			String path = dir.getPath();
			if(!path.toLowerCase().endsWith(".xlsx")) {
				path += ".xlsx";
				dir = new File(path);
			}
			System.out.println("saveExcelChooser1:" + path);
		}
		return dir;
	}

	/**
	 * Excel·ѡָĬ·
	 * @param defaultFile Ĭ·
	 * @return ѡExcel·ļ
	 */
	public static File saveExcelChooser(String defaultFile) {
		File dir = null;
		JFileChooser chooser = new JFileChooser();
		chooser.setAcceptAllFileFilterUsed(false);
//		File currentDir = FileSystemView.getFileSystemView().getDefaultDirectory();
		File desktopDir = FileSystemView.getFileSystemView().getHomeDirectory();
		chooser.setCurrentDirectory(desktopDir);
		chooser.setSelectedFile(new File(defaultFile));
		String saveType[] = { "xlsx" };
		chooser.setFileFilter(new FileNameExtensionFilter("Excel", saveType));
		int returnVal = chooser.showSaveDialog(new Frame());
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			dir = chooser.getSelectedFile();
			String path = dir.getPath();
			if(!path.toLowerCase().endsWith(".xlsx")) {
				path += ".xlsx";
				dir = new File(path);
			}
			if(dir.exists())
				dir.delete();
//			System.out.println("saveExcelChooser1:" + dir.getPath());
		}
		return dir;
	}

	/**
	 * Excel·ѡָڣ
	 * @param defaultFile 
	 * @return ѡExcel·ļ
	 */
	public static File saveExcelChooser(JDialog parent) {
		File dir = null;
		JFileChooser chooser = new JFileChooser();
		chooser.setAcceptAllFileFilterUsed(false);
//		File currentDir = FileSystemView.getFileSystemView().getDefaultDirectory();
		File desktopDir = FileSystemView.getFileSystemView().getHomeDirectory();
		chooser.setCurrentDirectory(desktopDir);
		String saveType[] = { "xlsx" };
		chooser.setFileFilter(new FileNameExtensionFilter("Excel", saveType));
		int returnVal = chooser.showSaveDialog(parent);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			dir = chooser.getSelectedFile();
			String path = dir.getPath();
			if(!path.toLowerCase().endsWith(".xlsx")) {
				path += ".xlsx";
				dir = new File(path);
			}
			System.out.println("saveExcelChooser1:" + path);
		}
		return dir;
	}

	/**
	 * жǷָ
	 * @param array Ҫжϵ
	 * @param target ָ
	 * @return true򷵻false
	 */
	public static boolean contains(Object[] array, Object target) {
		for(Object s : array) {
//			System.out.println("contains:"+s+"="+str);
			if(s.equals(target))
				return true;
		}
		return false;
	}
	
	public static Map<String, String> executeToMap(InputStream in){
		System.out.println("Read properties file");
		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(in, "utf-8"));
			String line = null;
			Map<String, String> resultMap = new LinkedHashMap<>(16);
			if (reader.ready()) {
				while (null != (line = reader.readLine())) {
					if (line.length() <= 0 || line.startsWith("#") || !line.contains("=")) {
						continue;
					}
					resultMap.put(line.substring(0, line.indexOf("=")), line.substring(line.indexOf("=") + 1));
				}
			}
			in.close();
			reader.close();
			return resultMap;
		} catch (Exception e) {
			e.printStackTrace();
			MessageBox.post("Find properties file failed", "ERROR", MessageBox.ERROR);
		}
		return null;
	}

	public static TCComponentDataset createExcelDataset(TCSession session, File file, String datasetName) throws Exception {
		String refType = null, objType = null, fileName = null;
		fileName = file.getName().toLowerCase();
		if (fileName.endsWith("xls")) {
			refType = "excel";
			objType = "MSExcel";
		} else if (fileName.endsWith("xlsx")) {
			refType = "excel";
			objType = "MSExcelX";
		}
		TCComponentDatasetType compType = (TCComponentDatasetType) session.getTypeService().getTypeComponent("Dataset");
		TCComponentDataset dataset = compType.create(datasetName, "description", objType);
		dataset.setFiles(new String[] { file.getAbsolutePath() }, new String[] { refType });
		return dataset;
	}
	
	public static Vector<TCComponent> getChildren(TCComponent parent, String relation, String name) throws Exception {
		Vector<TCComponent> result = new Vector<>();
		AIFComponentContext[] children;
		if(relation==null || relation.isEmpty())
			children = parent.getChildren();
		else
			children = parent.getChildren(relation);
		for(AIFComponentContext c : children) {
			TCComponent comp = (TCComponent) c.getComponent();
			if(comp.getProperty("object_name").equals(name))
				result.add(comp);
		}
		return result;
	}
	/**
	 * ȡָϵӼnull
	 * @param parent 
	 * @param relation ָϵ
	 * @return Ӽ
	 */
	public static AIFComponentContext[] getChildren(TCComponent parent, String relation) throws Exception {
		AIFComponentContext[] fs = parent.getChildren(relation);
		if(fs==null || fs.length==0)
			return new AIFComponentContext[] {  };
		if(fs.length>1)
			return fs;
		InterfaceAIFComponent fc = fs[0].getComponent();
		if(fc instanceof TCComponentPseudoFolder)
			return fc.getChildren();
		return fs;
	}
	/**
	 * ΪTC
	 * @param TCComponent 
	 * @param property ո
	 * @return ȷ˳
	 */
	public static TCComponent[] TCsort(TCComponent[] TCComponent, String property) {
		HashMap<TCComponent,String> map = new HashMap<>();
		int count = TCComponent.length;
		for(TCComponent Component : TCComponent) {
			try {
				map.put(Component, Component.getProperty(property));
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
        // ͨArrayList캯map.entrySet()תlist
		ArrayList<Map.Entry<TCComponent, String>> list = new ArrayList<Map.Entry<TCComponent, String>>(map.entrySet());
        // ͨȽʵֱȽ
        Collections.sort(list, new Comparator<Map.Entry<TCComponent, String>>() {
            public int compare(Map.Entry<TCComponent, String> mapping1, Map.Entry<TCComponent, String> mapping2) {
                return mapping1.getValue().compareTo(mapping2.getValue());
            }
        });
		TCComponent = new TCComponent[count];
		int i=0;
		for(Map.Entry<TCComponent, String> mapping : list) {
			TCComponent[i] = mapping.getKey();
			i++;
		}
		return TCComponent;
	}
	
	public static String getStackTrace(Exception e) {
		e.printStackTrace();
		StringBuilder rError = new StringBuilder(""+e.getMessage());
		for(StackTraceElement ste : e.getStackTrace()) {
			rError.append("\n\t"+ste.toString());
		}
//		System.out.println(rError.toString());
		return rError.toString();
	}

	/**
	 * ȡExcel
	 * @param sheet sheetҳ
	 * @param i к
	 * @return Excelж
	 */
	public static XSSFRow getRow(XSSFSheet sheet, int i) throws Exception {
		XSSFRow row = sheet.getRow(i);
		if(row==null)
			row = sheet.createRow(i);
		return row;
	}
	/**
	 * ȡExcelԪ
	 * @param row Ԫ
	 * @param col Ԫк
	 * @return ExcelԪ
	 */
	public static XSSFCell getCell(XSSFRow row, int col) throws Exception {
		XSSFCell cell = row.getCell(col);
		if(cell==null)
			cell = row.createCell(col);
		return cell;
	}

	/**
	 * 򿪻ر·
	 * @param session TCSession
	 * @param open ΪtrueرΪfalse
	 */
	@SuppressWarnings("deprecation")
	public static void setByPass(TCSession session, boolean open) throws Exception {
		session.getUserService().call("setbypass", new Object[] { open ? "true" : "false" });
	}
	/**
	 * ȡ̬LOVֵ
	 * @param session TCSession
	 * @param lov ָ̬LOV
	 * @return ̬LOVֵ
	 */
	public static String[] getDynamicLOV(TCSession session, TCComponentListOfValues lov) throws Exception {
		Vector<String> lovDisplayValueList = new Vector<>();
//		lovDisplayValueList.add("");
		Vector<String> lovValueList = new Vector<>();
		LOVService lovService = LOVService.getService(session);
		InitialLovData input = new InitialLovData();
		LovFilterData filter = new LovFilterData();
		filter.sortPropertyName = "object_name";
		filter.order = 1;
		filter.numberToReturn = 100;
		filter.maxResults = 100;

		input.lov = lov;
		input.filterData = filter;
		LOVSearchResults result = lovService.getInitialLOVValues(input);
//		StringBuffer sb = new StringBuffer();
//		sb.append(">>");
		for (LOVValueRow row : result.lovValues) {
			Map<String, String[]> map = row.propDisplayValues;
			Map<String, String[]> realmap = row.propInternalValues;
			for (String key : map.keySet()) {
//				sb.append("UID:" + row.uid + ",key:" + key + "value:" + map.get(key)[0]);
//				sb.append("\n");
				lovDisplayValueList.add(map.get(key)[0]);
				lovValueList.add(realmap.get(key)[0]);
			}
		}
//		System.out.println("StringBuffer:"+sb.toString());
		return lovDisplayValueList.toArray(new String[lovDisplayValueList.size()]);
	}
}
